# 复购留存代码使用说明
* 原始数据必须要有的两列：user_id, active_time，其他可以累加的量需要在代码中指定字段，数据记录的是实体发生动作的时间，程序处理的结果是各个时间段内首次发生动作的实体在随后的时间段内的行为表现
* retention.py是处理程序，举例说明实用方法：
    1. 计算次日、7日、30日留存率（产出矩形矩阵）：
        Retention(loop=[0, 1, 7, 30], period='day', mode='rate')
    2. 计算次日、7日、30日留存数（产出矩形矩阵）：
        Retention(loop=[0, 1, 7, 30], period='day', mode='count')
    3. 计算次日、7日、30日的当天消费额（产出矩形矩阵）：
        Retention(loop=[0, 1, 7, 30], period='day', mode='sum', sum_word='order_amount')
    4. 计算月留存率（产出三角形矩阵）：
        Retention(period='month', mode='rate')
    5. 计算月留存数（产出三角形矩阵）：
        Retention(period='month', mode='count')
    6. 计算月消费额（产出三角形矩阵）：
        Retention(period='month', mode='sum', sum_word='order_amount')
* map_reduce_retention.py用于处理大量数据：  
    //切成n个小块  
    mrr = MapReduceRetention(n)  
    //将任务分发到不同的csv中  
    mrr.slice_to_csv('data.csv')  
    eg1: 次月、再次月留存数，留存率or累加某字段参考retention.py  
    //拆分计算任务，注意此处的mode只能为count和sum，否则比例没有办法reduce  
    mrr.map_task(loop=[0, 1, 2], period='month', mode='count')  
    //合并计算任务，注意此处的mode只能为rate和count  
    mrr.reduce_task(mode='rate', shape='react')  
    //清理temp目录  
    mrr._clear_dir()
* 时间参数：  
    day, week, quarter, month, halfyear, year

# 时间分布代码使用说明
对数据量不敏感，包含time字段即可，可以按0～59秒（second）、0～59分（minute）、0～23时（hour）、周一～周日（dayofweek）、1号～31号（day）、1～52周（week）、1～12月（month）、年（year）进行分布

# 预览数据库字段
可以预览指定表或者库下所有表，默认distinct count <= 300会列出各个字段比例，可设置。可以指定是否产生csv文件

# 号码归属地查询
指定库、表、phone字段名称，可以生成指定名称的两列电话号码csv文件，也可以自己上传已经整理好的csv文件，tag_location负责生成归属地，包括运营商、省、市

# 导数据的工具 demo中的transport.py
这个工具重点解决了未知编码的转码，在handle中利用pandas操作，尽情地清洗数据