from sccddtools.phone import Phone
import pandas as pd  

phone_query = Phone()
def phone2location(data):
    try:
        info = phone_query.find(data.loc['phone'])
    except Exception as e:
        info = None
        print(e)
    if info:
        data.loc['province'] = info['province']
        data.loc['city'] = info['city']
        data.loc['phone_type'] = info['phone_type']
    return data

def tag_location(source=None, write_name=None):
    df = pd.read_csv(source)
    df['province'] = None
    df['city'] = None
    df['phone_type'] = None
    df = df.apply(phone2location, axis=1)
    df.to_csv(write_name, encoding='utf_8_sig')


if __name__ == '__main__':
    tag_location()