import pandas as pd
from sqlalchemy import create_engine


def cal_ratio(data):
    data.loc['ratio'] = data.loc['count'] / data.loc['count']


def preview_table(table=None, cancount_num=300, gen_csv=False, engine=None, path=None):
    sql = 'select * from {} limit 1'.format(table)
    df = pd.read_sql(sql=sql, con=engine)
    for column in df.columns:
        count_df = pd.read_sql('select count(distinct `{}`) as count from `{}`'.format(
            column, table), con=engine)
        if count_df.iloc[0]['count'] <= cancount_num:
            print('正在预览表【{}】---列【{}】'.format(table, column))
            preview_df = pd.read_sql('select `{}`, count(`{}`) as count from `{}` group by `{}`'.format(
                column, column, table, column), con=engine)
            preview_df['ratio'] = preview_df['count'] / \
                preview_df['count'].sum()
            preview_df['ratio'] = preview_df['ratio'].map(
                lambda x: '%' + str(format(round(x*100, 2))))
            print(preview_df)
            if gen_csv:
                preview_df.to_csv(
                    '{}/preview_{}_{}.csv'.format(path, table, column), encoding='utf_8_sig')


def visit_db(gen_csv=False, engine=None, cancount_num=300, path=None):
    table_df = pd.read_sql('show tables', con=engine)
    table_df.columns = ['table_name']
    for index, row in table_df.iterrows():
        print('开始预览table:{}'.format(row['table_name']))
        preview_table(table=row['table_name'], gen_csv=gen_csv,
                      engine=engine, cancount_num=cancount_num, path=path)


if __name__ == '__main__':
    from utils import create_con
    engine = create_con(dbname='clicbot')
    # 指定表进行预览
    tables = ['test']
    for table in tables:
        preview_table(table=table, engine=engine,
                      gen_csv=True, cancount_num=10)

    # 遍历数据库下所有表
    # 产生csv文件
    # visit_db(gen_csv=True, engine=engine)
    # 不产生csv文件，直接看打印结果
    visit_db(gen_csv=False, engine=engine, cancount_num=10)
