
from sqlalchemy import create_engine
import configparser
import execjs

def create_con(rds_conf):
    username = rds_conf['username']
    password = rds_conf['password']
    host = rds_conf['host']
    port = rds_conf['port']
    dbname = rds_conf['dbname']
    engine = create_engine(
        'mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8'.format(username, password, host, port, dbname))
    return engine

def decode2utf8(source=None, write_name=None):
    js = execjs.compile(
        '''
            const iconv = require('iconv-lite');
            const fs = require('fs');
            function decode2utf8(source, write_name) {
                console.log(`heiheihei${source}`)
                const fileStr = fs.readFileSync(`${source}`, {encoding:'binary'});
                const buf = new Buffer(fileStr, 'binary');
                const str = iconv.decode(buf, 'GBK');
                fs.writeFileSync(`${write_name}`, str);
            }
        '''
    )
    js.call('decode2utf8', source, write_name)

class SccConfigParser(configparser.ConfigParser):
    def as_dict(self):
        d = dict(self._sections)
        for k in d:
            d[k] = dict(d[k])
        return d

if __name__ == '__main__':
    decode2utf8('../toupload/2019.04.xlsx', '../temp/temp.csv')